## initrd-progs 1.0-3

=== CMakeLists.txt ===
# Generic info
cmake_minimum_required(VERSION 2.6)
project(initrd-progs C)
set(initrd-progs_VERSION 1.0)

# Compiler flags
set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS}
    -D_GNU_SOURCE -D_FORTIFY_SOURCE=2)
set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS}
    -pedantic -std=c99 -fvisibility=hidden -fmessage-length=0
    -fdiagnostics-show-option -ffast-math -O -Wfatal-errors
    -Wall -Wextra -Wformat=2 -Winit-self -Wunknown-pragmas
    -Wmissing-include-dirs -Wswitch-default -Wswitch-enum -Wunused -ftree-vrp
    -Wfloat-equal
    -Wundef -Wshadow -Wno-overlength-strings
    -Wbad-function-cast -Wcast-qual -Wcast-align -Wno-variadic-macros
    -Wwrite-strings -Waggregate-return
    -Wmissing-noreturn -Wmissing-format-attribute -Wnormalized=nfkc -Wpacked
    -Wredundant-decls -Wnested-externs -Winline
    -Winvalid-pch -Wvolatile-register-var -Wdisabled-optimization
    -fstrict-aliasing -Wimport -Wdisabled-optimization)
add_definitions(${CMAKE_REQUIRED_DEFINITIONS}
    -Wold-style-definition -Wmissing-prototypes
    -Wmissing-declarations -Wstrict-prototypes)

# Dependencies
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules")
find_package(Popt REQUIRED)

# Checks
include(CheckIncludeFile)
include(CheckSymbolExists)

check_include_file("linux/omapfb.h" HAVE_LINUX_OMAPFB_H "-Dsize_t=__u32")
if(NOT HAVE_LINUX_OMAPFB_H)
  set(LINUX_SRC_DIR "/usr/src/linux" CACHE PATH "Path to Linux kernel sources")
  if(NOT IS_DIRECTORY "${LINUX_SRC_DIR}")
	    message(FATAL_ERROR "No Linux sources found at ${LINUX_SRC_DIR}. Set LINUX_SRC_DIR variable to directory with Linux sources")
  endif()

  set(CMAKE_REQUIRED_INCLUDES "${LINUX_SRC_DIR}/include")
  unset(HAVE_LINUX_OMAPFB_H CACHE)
  check_include_file("linux/omapfb.h" HAVE_LINUX_OMAPFB_H "-Dsize_t=__u32")
  if(NOT HAVE_LINUX_OMAPFB_H)
      check_include_file("asm-arm/arch-omap/omapfb.h" HAVE_ARCH_OMAP_OMAPFB_H)
      if(NOT HAVE_ARCH_OMAP_OMAPFB_H)
          message(FATAL_ERROR "omapfb.h not found")
      endif()
  endif()
  include_directories(AFTER SYSTEM ${CMAKE_REQUIRED_INCLUDES})
endif()

check_include_file(mtd/mtd-user.h HAVE_MTD_USER_H "-D__user=")
if(NOT HAVE_MTD_USER_H)
    message(FATAL_ERROR "Your system doesn't have mtd/mtd-user.h")
endif()

check_include_file(stdbool.h HAVE_STDBOOL_H)
if(NOT HAVE_STDBOOL_H)
    message(FATAL_ERROR "Your system doesn't have stdbool.h")
endif()

check_symbol_exists(asprintf stdio.h HAVE_ASPRINTF)
if(NOT HAVE_ASPRINTF)
    message(FATAL_ERROR "Your system doesn't have asprintf(3) function")
endif()

check_symbol_exists(pread unistd.h HAVE_PREAD)
if(NOT HAVE_PREAD)
    message(FATAL_ERROR "Your system doesn't have pread(2) function")
endif()

# config.h
configure_file("${PROJECT_SOURCE_DIR}/config.h.in" "${PROJECT_BINARY_DIR}/config.h")
include_directories("${PROJECT_BINARY_DIR}")

# Executables
add_executable(text2screen text2screen.c)
target_link_libraries(text2screen ${Popt_LIBRARY})

add_executable(cal-tool cal-tool.c)
target_link_libraries(cal-tool ${Popt_LIBRARY} cal)

add_executable(key_pressed key_pressed.c)

# Installation
install(TARGETS text2screen cal-tool key_pressed RUNTIME DESTINATION bin)

=== debian/changelog ===
initrd-progs (1.0-3) unstable; urgency=low

  * Fix memory leak

 -- Pali Rohár <pali.rohar@gmail.com>  Sat, 19 Mar 2016 16:05:46 +0100

initrd-progs (1.0-2) unstable; urgency=low

  * Accept colors for text2screen in RGB565 format too
  * Do not clear background in text mode if bg_color is not specified

 -- Pali Rohár <pali.rohar@gmail.com>  Wed, 24 Apr 2013 21:50:10 +0200

initrd-progs (1.0-1) unstable; urgency=low

  * Initial release

 -- Pali Rohár <pali.rohar@gmail.com>  Mon, 31 Dec 2012 17:55:40 +0100

=== debian/control ===
Source: initrd-progs
Section: utils
Priority: optional
Maintainer: Pali Rohár <pali.rohar@gmail.com>
Build-Depends: debhelper (>= 5), cmake, libpopt-dev, libcal-dev, kernel-headers
Standards-Version: 3.9.3

Package: initrd-progs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Initfs utilities (FIXME)
 Initfs utilities (FIXME)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

builddir/Makefile:
	dh_testdir
	mkdir -p builddir
	cd builddir && cmake .. -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_C_FLAGS="$(CFLAGS)" -DCMAKE_LD_FLAGS="-Wl,-z,defs" -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" -DCMAKE_SKIP_RPATH=ON -DCMAKE_VERBOSE_MAKEFILE=ON -DLINUX_SRC_DIR=/usr/src/kernel-headers

build: build-stamp

build-stamp:  builddir/Makefile
	dh_testdir
	$(MAKE) -C builddir
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -rf builddir
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	$(MAKE) -C builddir DESTDIR=$(CURDIR)/debian/initrd-progs install

binary-indep: install

binary-arch: install
	dh_testdir
	dh_testroot
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
